NEConfig = {}

require "config"
require "scripts.detectmod" --Detect supported Mods, currently DyTechWar and Bob's Enemies

require("prototypes.item")
require("prototypes.recipe")
require("prototypes.entity")
require("prototypes.technology")

---------------------------------------------------------------
---------------------------------------------------------------


---- Evolution Modifications ----------------------------------
if NEConfig.EvolutionFactor then

-- TIME: Only 75% of vanilla
-- percentual increase in the evolve factor for every second (60 ticks). Default = 0.000008
data.raw["map-settings"]["map-settings"]["enemy_evolution"].time_factor = 0.00000006

-- POLLUTION: Double the vanilla Pollution Evolution, so don't pollute!
-- percentual increase in the evolve factor for 1000 PU. Default = 0.00003          
data.raw["map-settings"]["map-settings"]["enemy_evolution"].pollution_factor = 0.00006

-- KILLING EMENY SPAWNERS: 5 times less Evolution increase for killing Enemy Spawners
-- percentual increase in the evolve factor for every destroyed spawner. Default = 0.005
data.raw["map-settings"]["map-settings"]["enemy_evolution"].destroy_factor = 0.001


end
---- END Evolution Modifications ----------------------------------


---- Spawner Modifications ----------------------------------------
if NEConfig.Spawners then
	
-- Biter Spawner Adjustments
data.raw["unit-spawner"]["biter-spawner"].max_count_of_owned_units = 30
data.raw["unit-spawner"]["biter-spawner"].max_friends_around_to_spawn = 20
data.raw["unit-spawner"]["biter-spawner"].spawning_cooldown = {500, 150}
data.raw["unit-spawner"]["biter-spawner"].max_health = 2500
data.raw["unit-spawner"]["biter-spawner"].spawning_radius = 25
data.raw["unit-spawner"]["biter-spawner"].spawning_spacing = 2
data.raw["unit-spawner"]["biter-spawner"].max_spawn_shift = 0.65
data.raw["unit-spawner"]["biter-spawner"].pollution_cooldown = 8

-- Spitter Spawner Adjustments
data.raw["unit-spawner"]["spitter-spawner"].max_count_of_owned_units = 20
data.raw["unit-spawner"]["spitter-spawner"].max_friends_around_to_spawn = 15
data.raw["unit-spawner"]["spitter-spawner"].spawning_cooldown = {600, 180}
data.raw["unit-spawner"]["spitter-spawner"].max_health = 3500
data.raw["unit-spawner"]["spitter-spawner"].spawning_radius = 20
data.raw["unit-spawner"]["spitter-spawner"].spawning_spacing = 2
data.raw["unit-spawner"]["spitter-spawner"].max_spawn_shift = 0.65
data.raw["unit-spawner"]["spitter-spawner"].pollution_cooldown = 8

	-- Bob's Enemies Modifications
	if NEConfig.mod.BobEnemies then

	-- Bob's Biter Spawner Adjustments
	data.raw["unit-spawner"]["bob-biter-spawner"].max_count_of_owned_units = 30
	data.raw["unit-spawner"]["bob-biter-spawner"].max_friends_around_to_spawn = 20
	data.raw["unit-spawner"]["bob-biter-spawner"].spawning_cooldown = {500, 150}
	data.raw["unit-spawner"]["bob-biter-spawner"].max_health = 2500
	data.raw["unit-spawner"]["bob-biter-spawner"].spawning_radius = 25
	data.raw["unit-spawner"]["bob-biter-spawner"].spawning_spacing = 2
	data.raw["unit-spawner"]["bob-biter-spawner"].max_spawn_shift = 0.65
	data.raw["unit-spawner"]["bob-biter-spawner"].pollution_cooldown = 8

	-- Bob's Spitter Spawner Adjustments
	data.raw["unit-spawner"]["bob-spitter-spawner"].max_count_of_owned_units = 20
	data.raw["unit-spawner"]["bob-spitter-spawner"].max_friends_around_to_spawn = 15
	data.raw["unit-spawner"]["bob-spitter-spawner"].spawning_cooldown = {600, 180}
	data.raw["unit-spawner"]["bob-spitter-spawner"].max_health = 3500
	data.raw["unit-spawner"]["bob-spitter-spawner"].spawning_radius = 20
	data.raw["unit-spawner"]["bob-spitter-spawner"].spawning_spacing = 2
	data.raw["unit-spawner"]["bob-spitter-spawner"].max_spawn_shift = 0.65
	data.raw["unit-spawner"]["bob-spitter-spawner"].pollution_cooldown = 8

	end

end
---- END Spawner Modifications ----------------------------------------


---- Biter & Spitter Modifications --------------------------------
if NEConfig.BiterSpitter then
	
-- Vanilla Unit Adjustments
data.raw["unit"]["medium-biter"].pollution_to_join_attack = 800
data.raw["unit"]["big-biter"].pollution_to_join_attack = 800

-- Bob's Enemies Modifications
	if NEConfig.mod.BobEnemies then

	data.raw["unit"]["bob-bigger-biter"].pollution_to_join_attack = 1000
	data.raw["unit"]["bob-biggest-biter"].pollution_to_join_attack = 2500
	data.raw["unit"]["bob-fire-biter"].pollution_to_join_attack = 5000
	data.raw["unit"]["bob-bigger-spitter"].pollution_to_join_attack = 1000
	data.raw["unit"]["bob-biggest-spitter"].pollution_to_join_attack = 2500
	data.raw["unit"]["bob-poison-spitter"].pollution_to_join_attack = 5000

	end
	
	
-- DyTechWar Modifications
	if NEConfig.mod.DyTechWar then
	
	data.raw["unit"]["berserk-biter"].pollution_to_join_attack = 1000
	data.raw["unit"]["elder-biter"].pollution_to_join_attack = 2500
	data.raw["unit"]["king-biter"].pollution_to_join_attack = 5000
	data.raw["unit"]["queen-biter"].pollution_to_join_attack = 5000
	data.raw["unit"]["berserk-spitter"].pollution_to_join_attack = 1000
	data.raw["unit"]["elder-spitter"].pollution_to_join_attack = 2500
	data.raw["unit"]["king-spitter"].pollution_to_join_attack = 5000
	data.raw["unit"]["queen-spitter"].pollution_to_join_attack = 5000

	end
		
end
---- END Biter & Spitter Modifications --------------------------------